package com.megabras.bluelogg.extended;

import android.os.Message;
import android.util.Log;

import java.text.DecimalFormat;
import java.util.Date;

public class LogCat
{
    private final String
            TAG = "Log";

    private Date
            dateOld = new Date();

    private DecimalFormat
            typeFormat = new DecimalFormat("+00;-00");

    private String
            //header = " ip | fc | addr | regs | byt| data (crc)";
            //header = "%6s | %3s | %2s | %2s | %4s | %-4s | %2s | %-50s | %-3s";
            header = "%6s  %3s  %2s  %2s  %4s  %-4s  %2s  %-50s  %-3s";

    public static final short
            LEVEL_NONE    = 0,
            LEVEL_NO_PING = 1,
            LEVEL_ALL     = 2;

    public static short
            LEVEL         = 2;

    public static int
            STATUS_ID     = -1;

    private boolean
            showHeader = true;

    public void logcatRx(Message msg)
    {
        try
        {
            String message = (String)msg.obj;
            if (LEVEL==LEVEL_ALL || (LEVEL==LEVEL_NO_PING && msg.arg2!=STATUS_ID))
            {
                //Log.e(TAG, "Rx> " + formatElapsed() + typeFormat.format(msg.arg2) + formatStringRx(message).replace("\r\n", "") + "\n ");
                //Log.e(TAG, formatStringRx(msg).replace("\r\n", "") + "\n ");
                Log.e("Rx", formatStringRx(msg));
                showHeader = true;
            }
        }
        catch (Exception ignored)
        {
        }
    }

    public void logcatTx(Message msg)
    {
        try
        {
            String message = (String) msg.obj;
            if (LEVEL==LEVEL_ALL || (LEVEL==LEVEL_NO_PING && msg.arg2!=STATUS_ID))
            {
                if (showHeader)
                {
                    //Log.e("--", "--------------------------------------------------------------------------------------------------------");
                    Log.e("--", "________________________________________________________________________________________________________");
                    String hea = String.format(header, "MS", "COD", "IP", "FC", "ADDR", "REG", "BY", "DATA", "CRC");
                    Log.e("--", hea);
                    //Log.e(TAG, "    ms    | cod |" + header);

                }
                //Log.e(TAG, "Tx> " + formatElapsed() + typeFormat.format(msg.arg2) + formatStringTx(message));
                Log.e("Tx", formatStringTx(msg));
                showHeader = false;
            }
        }
        catch (Exception ignored)
        {
        }
    }

    private String formatElapsed()
    {
        Date dateNow = new Date();
        String elapsed = (dateNow.getTime() - dateOld.getTime()) + "";
        dateOld = dateNow;
//        int len = 5;
//        if (elapsed.length()<len)
//        {
//            int miss = len - elapsed.length();
//            for (int i=0; i<miss; i++)
//            {
//                elapsed = " " + elapsed;
//            }
//            elapsed = elapsed + " ";
//        }
        return elapsed;
    }

    private String formatStringRx(Message msg)
    {
        String message = (String) msg.obj;
        try
        {
            message = message.replaceAll(" ", "");
            message = message.replaceAll("\r\n", "");
            String result = header;
            String ip;
            String fc;
            String reg    = "    ";
            String ad     = "    ";
            String bytes  = "  ";
            String data   = "";
            String crc;
            if (message.startsWith("0103"))
            {
                ip   = message.substring(0, 2);
                fc   = message.substring(2, 4);
                bytes= message.substring(4, 6);
                data = "";
                for (int i = 6; i < (message.length() - 2); i = i + 4)
                    data += message.substring(i, i+4)  + " ";
                crc  = message.substring(message.length()-2);
            }
            else if (message.startsWith("0110"))
            {
                ip   = message.substring(0, 2);
                fc   = message.substring(2, 4);
                ad   = message.substring(4, 8);
                reg  = message.substring(8, 12);
                crc  = message.substring(message.length()-2);
            }
            else
            {
                ip   = message.substring(0, 2);
                fc   = message.substring(2, 4);
                ad   = message.substring(4, 8);
                data = message.substring(8, 12);
                crc  = message.substring(message.length()-2);
            }
            result = result.replace("ip", ip);
            result = result.replace("fc", fc);
            result = result.replace("addr", ad);
            result = result.replace("regs", reg);
            result = result.replace("byt", bytes + "");
            result = result.replace("data", data);
            result = result.replace("crc", crc);

            String hea = String.format(header, formatElapsed(), typeFormat.format(msg.arg2), ip, fc, ad, reg, bytes, data, crc);

            return hea;
        }
        catch (Exception e)
        {
            return message;
        }
    }

    private String formatStringTx(Message msg)
    {
        String message = (String) msg.obj;
        try {
            message = message.replaceAll(" ", "");
            String result = header;
            String ip;
            String fc;
            String reg    = "    ";
            String ad     = "    ";
            String bytes  = "  ";
            String data   = "";
            String crc;
            StringBuilder b = new StringBuilder(message);
            if (message.startsWith("0110"))
            {
                ip   = message.substring(0, 2);
                fc   = message.substring(2, 4);
                ad   = message.substring(4, 8);
                reg  = message.substring(8, 12);
                bytes= message.substring(12, 14);
                data = "";
                for (int i = 14; i < (message.length() - 2); i = i + 4)
                    data += message.substring(i, i+4)  + " ";
                crc  = message.substring(message.length()-2);
            }
            else if (message.startsWith("0103"))
            {
                ip   = message.substring(0, 2);
                fc   = message.substring(2, 4);
                ad   = message.substring(4, 8);
                reg  = message.substring(8, 12);
                crc  = message.substring(message.length()-2);
            }
            else
            {
                ip   = message.substring(0, 2);
                fc   = message.substring(2, 4);
                ad   = message.substring(4, 8);
                data = message.substring(8, 12);
                crc  = message.substring(message.length()-2);
            }
            result = result.replace("ip", ip);
            result = result.replace("fc", fc);
            result = result.replace("addr", ad);
            result = result.replace("regs", reg);
            result = result.replace("byt", bytes + "");
            result = result.replace("data", data);
            result = result.replace("crc", crc);

            String hea = String.format(header, formatElapsed(), typeFormat.format(msg.arg2), ip, fc, ad, reg, bytes, data, crc);

            return hea;
        }
        catch (Exception e)
        {
            return message;
        }
    }
}
