package com.megabras.bluelogg.md10kvx;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Paint.Align;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.util.TypedValue;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TableRow;
import android.widget.TableRow.LayoutParams;
import android.widget.TextView;

import com.megabras.bluelogg.R;
import com.megabras.bluelogg.extended.TableValues;

import org.achartengine.ChartFactory;
import org.achartengine.GraphicalView;
import org.achartengine.model.XYMultipleSeriesDataset;
import org.achartengine.model.XYSeries;
import org.achartengine.renderer.XYMultipleSeriesRenderer;
import org.achartengine.renderer.XYSeriesRenderer;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

public class MD10KVxFragmentChart extends Fragment implements MD10KVxChartInterface{
	@SuppressWarnings("unused")
	private final String TAG = "MD10KVxFragmentChart";
	public static final int RESISTANCE_CHART = 0;
	public static final int VOLTAGE_CHART = 1;
	public static final int CURRENT_CHART = 2;
	public static final int TABLE = 3;
	private int CHART_TYPE = -1;
	private XYSeries mXYSeriesResistance;
	private GraphicalView mChartResistance;
	private double minY;
	private double maxY;
//	private double minYdefault;
//    private double maxYdefault;
    //protected double margen;
	//protected double minGapFactor = 0.2;
	private XYMultipleSeriesRenderer mRenderer;
//	private DecimalFormat dosDigitos;
	//protected static final String[] UNITS = {"", "k", "M", "G", "T"};
    //protected static final String[] NEGUNITS = {"", "m", "\u00B5", "n", "p", "f"};
    private final long MILI = 1000;
	private final long MICRO = MILI * 1000;
	private final long NANO = MICRO * 1000;
	private final long PICO = NANO * 1000;
	//private final long FEMTO = PICO * 1000;	
	private final long KILO = 1000;
	private final long MEGA = KILO * 1000;
	private final long GIGA = MEGA * 1000;
	private final long TERA = GIGA * 1000;
	private LinearLayout layout;
	//private TableLayout tv;
	private ListView list;
	private long POWER = 0;
    private TableBaseAdapter adapter;
    private List<TableValues> tableValues = new ArrayList<>();
    private long CHART_CORRECTION = 0;
    private Calendar calendar;
	private String chartTitle = "";
	private Context context;

	@Override
	public View onCreateView( @NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState )
	{
		calendar = Calendar.getInstance();
		calendar.setTime( new Date() );
		calendar.set( Calendar.MILLISECOND, 0 );
		calendar.set( Calendar.SECOND, 0 );
		calendar.set( Calendar.MINUTE, 0 );
		calendar.set( Calendar.HOUR_OF_DAY, 0 );
		CHART_CORRECTION = calendar.getTimeInMillis();
		context = inflater.getContext();
		return inflater.inflate( R.layout.md10kvx_fgr_online, container, false );
	}

	@Override
	public void onStart()
	{
		super.onStart();
		createChart();
	}

	public void setChartType( int type, String chartTitle )
	{
		CHART_TYPE = type;
		this.chartTitle = chartTitle;
	}

	public int getChartType()
	{
		return CHART_TYPE;
	}

	private void createChart()
	{
		//power = Long.MAX_VALUE;
		minY = Double.MAX_VALUE;
		maxY = Double.MIN_VALUE;
		//dosDigitos = new DecimalFormat( "#.##" );

		switch ( CHART_TYPE )
		{
			case MD10KVxFragmentChart.RESISTANCE_CHART:
				Chart( chartTitle, "GOhm" );
				break;
			case MD10KVxFragmentChart.VOLTAGE_CHART:
				Chart( chartTitle, "V" );
				break;
			case MD10KVxFragmentChart.CURRENT_CHART:
				Chart( chartTitle, "A" );
				break;
			case 3:
				Table();
				break;
		}
	}

	public Bitmap getChartBitmap()
	{
		int gridColor   = mRenderer.getGridColor( 0 );
		int labelColor  = mRenderer.getLabelsColor();
		int yLabelColor = mRenderer.getYLabelsColor( 0 );
		int xLabelColor = mRenderer.getXLabelsColor();
		int axesColor   = mRenderer.getAxesColor();

		mRenderer.setGridColor( Color.argb( 60, 0, 0, 0 ) );
		mRenderer.setLabelsColor( Color.BLACK );
		mRenderer.setYLabelsColor( 0, Color.BLACK );
		mRenderer.setXLabelsColor( Color.BLACK );
		mRenderer.setAxesColor( Color.BLACK );

		mChartResistance.setDrawingCacheEnabled( true );
		Bitmap bitmap = mChartResistance.getDrawingCache();

		mRenderer.setGridColor( gridColor );
		mRenderer.setLabelsColor( labelColor );
		mRenderer.setYLabelsColor( 0, yLabelColor );
		mRenderer.setXLabelsColor( xLabelColor );
		mRenderer.setAxesColor( axesColor );
		return bitmap;
	}

	public void Table()
	{
		if ( this.getView() != null )
		{
			layout = this.getView().findViewById( R.id.chart );
		}
		else
		{
			return;
		}

		if ( layout.getChildCount() > 1 )
		{
			return;
		}
		
		LinearLayout header = new LinearLayout(layout.getContext());
		header.setLayoutParams(new LayoutParams( LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));
    	
    	TextView b1=new TextView(layout.getContext());
        b1.setText(context.getString( R.string.mmss ).toUpperCase());
        b1.setTextColor(Color.WHITE);
        //b1.setTextSize(15);        
        b1.setBackground( this.getResources().getDrawable(R.drawable.box_white) );
        b1.setPadding(9, 0, 0, 0);
        header.addView(b1, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, TableRow.LayoutParams.WRAP_CONTENT, 1f));

        TextView b2=new TextView(layout.getContext());        
        //b2.setTextSize(15);
        b2.setText("R");
        b2.setTextColor(Color.WHITE);
        b2.setBackground( this.getResources().getDrawable(R.drawable.box_white) );
        b2.setPadding(9, 0, 0, 0);
        header.addView(b2, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, TableRow.LayoutParams.WRAP_CONTENT, 1f));
        
        TextView b3=new TextView(layout.getContext());        
        //b3.setTextSize(15);
        b3.setText("V");
        b3.setTextColor(Color.WHITE);
        b3.setBackground( this.getResources().getDrawable(R.drawable.box_white) );
        b3.setPadding(9, 0, 0, 0);
        header.addView(b3, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, TableRow.LayoutParams.WRAP_CONTENT, 1f));
        
        TextView b4=new TextView(layout.getContext());                
        //b4.setTextSize(15);
        b4.setText("A");
        b4.setTextColor(Color.WHITE);
        b4.setBackground( this.getResources().getDrawable(R.drawable.box_white) );
        b4.setPadding(9, 0, 0, 0);
        header.addView(b4, new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, TableRow.LayoutParams.WRAP_CONTENT, 1f));
		
        layout.addView( header );	
        
        list = new ListView( layout.getContext() );
        list.setDividerHeight(0);
        layout.addView(list);
        
        adapter = new TableBaseAdapter( layout.getContext() );		 
		list.setAdapter( adapter );		
	}
	
	public int getTableSize(){
		if(adapter != null){			
			return adapter.getCount();
		} 
		else {
			return 0;
		}
	}
	
	public void showTable(boolean show){
		if(list!=null){
			if(show)
				list.setVisibility(View.VISIBLE);
			else
				list.setVisibility(View.GONE);
		}		
	}
		
	private void Chart( String chartTitle, String yTitle ){
		if(this.getView()!=null){
			layout = this.getView().findViewById(R.id.chart);
		}
		else{
			return;
		}

		if(layout.getChildCount()>0){
			return;
		}
	
	    XYMultipleSeriesDataset mDataset = new XYMultipleSeriesDataset();
	    mRenderer = new XYMultipleSeriesRenderer();
	    
	    XYSeriesRenderer mXYSeriesRenderer;
	    
	    mXYSeriesResistance = new XYSeries("Chart");
	    
        mDataset.addSeries(mXYSeriesResistance);
        
        mXYSeriesRenderer = new XYSeriesRenderer();
        mXYSeriesRenderer.setColor(Color.RED);        
        mXYSeriesRenderer.setFillPoints(true);
        mXYSeriesRenderer.setLineWidth(2);
//        minYdefault = mRenderer.getYAxisMin();
//        maxYdefault = mRenderer.getYAxisMax();

		DisplayMetrics metrics = context.getResources().getDisplayMetrics();

		mRenderer.setLabelsTextSize(
				TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, context.getResources().getDimension(R.dimen.chart_label), metrics)
		);

		mRenderer.setChartTitleTextSize(
				TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, context.getResources().getDimension(R.dimen.chart_title), metrics)
		);

		mRenderer.setAxisTitleTextSize(
				TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, context.getResources().getDimension(R.dimen.chart_title), metrics)
		);

        mRenderer.addSeriesRenderer(mXYSeriesRenderer);
        mRenderer.setAntialiasing(false);
        mRenderer.setShowLegend(false);
        mRenderer.setYTitle(yTitle);         
        mRenderer.setYLabelsAlign(Align.RIGHT);        
        mRenderer.setXTitle("h:mm:ss");
        mRenderer.setChartTitle(chartTitle);        
        mRenderer.setApplyBackgroundColor(true);        
        mRenderer.setBackgroundColor(Color.TRANSPARENT);
        mRenderer.setMarginsColor(Color.argb(0x00, 0x01, 0x01, 0x01));
        mRenderer.setAxesColor(Color.TRANSPARENT);
        mRenderer.setShowGrid(true);
        mRenderer.setGridColor(Color.argb(60, 255, 255, 255));
        mRenderer.setYLabels(6);
        mRenderer.setXLabels(8);
        
        //###Evita grid/Labels em posicoes como 5.135(segundos e millisegundos);
        //mRenderer.setXRoundedLabels(false);
        mRenderer.setXAxisMin(calendar.getTimeInMillis());                
        //top - left - bottom - right
		mRenderer.setMargins(new int[] { 25, 65, 0, 10 }); //top - left - bottom - right
        mRenderer.setPanEnabled(false, false);
        mRenderer.setZoomEnabled(false, false);
        
        mChartResistance = ChartFactory.getTimeChartView(
											context.getApplicationContext(),
        									mDataset,
        									mRenderer,
        									"H:mm:ss");
        
        layout.addView(mChartResistance);        
	}
	
	private double resolution(double value, String unit){
		double r;
		
		if(POWER==0){
			if(value>=TERA){					
				r = value / TERA;
				mRenderer.setYTitle("T"+unit);
				POWER=TERA;
			} else if(value>=GIGA){
				r = value / GIGA;
				mRenderer.setYTitle("G"+unit);
				POWER=GIGA;
			} else if(value>=MEGA){
				r = value / MEGA;
				mRenderer.setYTitle("M"+unit);
				POWER=MEGA;
			} else if(value>KILO){
				r = value / KILO;
				mRenderer.setYTitle("k"+unit);
				POWER=KILO;
			} else if (value >= 1) {
				r = value;
				mRenderer.setYTitle(unit);
				POWER=1;
			} else if(value*MILI>=1){				
				r = (value * MILI);
				mRenderer.setYTitle("m"+unit);
				POWER = MILI;
			} else if(value*MICRO>=1){				
				r = (value * MICRO);
				mRenderer.setYTitle("\u00B5"+unit);
				POWER = MICRO;
			} else if (value*NANO>=1) {				
				r = (value * NANO);
				mRenderer.setYTitle("n"+unit);
				POWER = NANO;
			} else if (value*PICO>=1) {				
				r = (value * PICO);
				mRenderer.setYTitle("p"+unit);
				POWER = PICO;
			} else {
				r = 0;
			}
		}  else {
			if(value >= 1){
				r = (value / POWER);
			} else {
				r = (value * POWER);
			}			
		}
		updateScaleY(r);
		return r;
	}
	
	private void updateScaleY(double newY) {		
		if (newY < minY) {
			minY = newY;                
		}
		
		if (newY > maxY) {
			maxY = newY;
		}            
		
		double diff = maxY - minY;
		double perc = (diff*100)/maxY; 
		perc = 100 - perc;
		perc = perc/100;
		double toAddMax = (maxY * perc)/2;
		double toAddMin = (maxY * perc)/2;
					
		double lowY = minY - toAddMin;
		double upY = maxY + toAddMax;
		
		if(lowY<0){
			lowY=0;
		}
		
		mRenderer.setYAxisMin(lowY);
		mRenderer.setYAxisMax(upY);
	 }

	
	// ##############################
	// MD10KVxChartInterface
	// ##############################
	
	public void update(MD10KVx parent, long milliseconds, float resistance, float voltage, float current, boolean repaint){
    	     	
    	float tempCurrent = parent.getSimpleVoltage(voltage)/resistance;    	
    	    			
		final boolean overrangeR = resistance>=(10*TERA);
		final boolean overrangeA = current<(1/PICO);
		
		if(overrangeR || overrangeA){
			resistance = 0;
			tempCurrent = 0;
		}
			
		switch (CHART_TYPE) {
        case 0:		        	
        	if(milliseconds==MD10KVx.INITIAL_VALUE)
        		mRenderer.setAxesColor(Color.WHITE);  
        	
        	if(overrangeR || overrangeA){
    			resistance = 0;
    		}        	
        	mXYSeriesResistance.add( milliseconds+CHART_CORRECTION, resolution(resistance, "\u03A9") );        			
        	
        	if(repaint)
        		mChartResistance.repaint();
        	break;
        case 1:
        	if(milliseconds==MD10KVx.INITIAL_VALUE)
        		mRenderer.setAxesColor(Color.WHITE);
        	mXYSeriesResistance.add( milliseconds+CHART_CORRECTION, resolution(voltage, "V") );
        	if(repaint)
        		mChartResistance.repaint();
        	break;
        case 2:
        	if(milliseconds==MD10KVx.INITIAL_VALUE)
        		mRenderer.setAxesColor(Color.WHITE);
        	if(overrangeR || overrangeA){
    			tempCurrent = 0;
    		}
        	mXYSeriesResistance.add( milliseconds+CHART_CORRECTION, resolution(tempCurrent, "A") );
        	if(repaint)
        		mChartResistance.repaint();
        	break;
        case 3:       
        	String formattedResistance = parent.resolutionR( resistance ); 
        	String formattedMilliseconds = String.format(Locale.US, "%02d", (milliseconds/1000)/60) + ":" + String.format(Locale.US, "%02d", (milliseconds/1000)%60);
        	String formattedVoltage = parent.resolutionV( voltage / KILO )  + " kV";
        	String calculatedCurrent = parent.resolutionA( tempCurrent );
        	
        	if(overrangeR || overrangeA){    			
    			calculatedCurrent = "0nA";  
    			formattedResistance = ">10T\u03A9";
    		}
        	
			adapter.add(
					formattedMilliseconds, 
					formattedResistance, 
					formattedVoltage, 
					calculatedCurrent );        	

			if(repaint)
				adapter.repaint();
        	break;
        }				
	}

	public void repaint(){
		
		switch (CHART_TYPE) {
        case 0:		        	
        	mChartResistance.repaint();		        	
        	break;
        case 1:		        	
        	mChartResistance.repaint();
        	break;
        case 2:		        	
        	mChartResistance.repaint();
        	break;
        case 3:		        	
        	adapter.repaint();
        	break;
        }
	}
	
	public void setAllValues(){		
		adapter.addAll(tableValues);
		//tableValues.clear();
	}

	public void reset(){
		try{
			if (layout==null){
				createChart();
			}
			if(CHART_TYPE==3){
				//tv.removeAllViews();
				tableValues.clear();
			} else {
				mXYSeriesResistance.clear();					
				mChartResistance.repaint();
				POWER = 0;
				minY = Double.MAX_VALUE;
				maxY = Double.MIN_VALUE;
			}			
		} catch (Exception e){
			android.util.Log.e("ERROR", e.getMessage()+"");
		}
	}
	
}
