package com.megabras.bluelogg.md10kvx;

import android.content.Context;
import android.graphics.drawable.Drawable;
//import android.support.v4.app.Fragment;
//import android.support.v4.app.FragmentManager;
//import android.support.v4.app.FragmentStatePagerAdapter;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.style.ImageSpan;

import com.megabras.bluelogg.R;
import com.megabras.bluelogg.md10kvx.MD10KVxChartInterface;
import com.megabras.bluelogg.md10kvx.MD10KVxFragmentChart;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentStatePagerAdapter;

public class PagerAdapter extends FragmentStatePagerAdapter {
	private Context context;
	private int numPages = 4;	
	private MD10KVxFragmentChart resistanceChart;
	private MD10KVxFragmentChart voltageChart;
	private MD10KVxFragmentChart currentChart;
	private MD10KVxFragmentChart table;	
	
	public PagerAdapter(FragmentManager fm, Context context) {
        super(fm);
        this.context = context;        
//        resistanceChart = new MD10KVxFragmentChart( MD10KVxFragmentChart.RESISTANCE_CHART );
//    	voltageChart = new MD10KVxFragmentChart( MD10KVxFragmentChart.VOLTAGE_CHART );
//    	currentChart = new MD10KVxFragmentChart( MD10KVxFragmentChart.CURRENT_CHART );
        resistanceChart = new MD10KVxFragmentChart();
        resistanceChart.setChartType( MD10KVxFragmentChart.RESISTANCE_CHART, context.getString( R.string.md_resistance) );
        voltageChart = new MD10KVxFragmentChart();
        voltageChart.setChartType( MD10KVxFragmentChart.VOLTAGE_CHART, context.getString(R.string.md_voltage) );
        currentChart = new MD10KVxFragmentChart( );
        currentChart.setChartType( MD10KVxFragmentChart.CURRENT_CHART, context.getString(R.string.md_current) );
    	table = new MD10KVxFragmentChart( );
        table.setChartType( MD10KVxFragmentChart.TABLE, "" );
    }

    @Override
    public Fragment getItem(int i) {
        switch (i) {
	        case 0:	        	
	        	return resistanceChart;
	        case 1:	        	
	        	return voltageChart;
	        case 2:
	        	return currentChart;
	        case 3:
	        	return table;	        
        }
        return null;
    }

    @Override
    public int getCount(){   	
        return numPages;
    }
    
    public MD10KVxChartInterface chartResistance(){
    	return resistanceChart;
    }
    
    public MD10KVxChartInterface chartVoltage(){
    	return voltageChart;
    }
    
    public MD10KVxChartInterface chartCurrent(){
    	return currentChart;
    }
    
    public MD10KVxChartInterface table(){
    	return table;
    }
    
    private int[] imageResId = {
            R.drawable.ic_chart_resistance,
            R.drawable.ic_chart_voltage,
            R.drawable.ic_chart_current,
            R.drawable.ic_table
    };
    
    @Override
    public CharSequence getPageTitle(int position) {
        Drawable image = context.getResources().getDrawable(imageResId[position]);
        image.setBounds(0, 0, image.getIntrinsicWidth(), image.getIntrinsicHeight());
        SpannableString sb = new SpannableString(" ");
        ImageSpan imageSpan = new ImageSpan(image, ImageSpan.ALIGN_BOTTOM);
        sb.setSpan(imageSpan, 0, 1, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
        return sb;
    }

}


