package com.megabras.bluelogg.tm25r;

import java.util.ArrayList;
import android.content.Context;
import android.graphics.Typeface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.megabras.bluelogg.R;
import com.megabras.bluelogg.tm25r.ListSites;

public class ListSitesDetails extends BaseAdapter {
	
	private LayoutInflater mInflater;
	private ArrayList<ListSites> itens;
	private int selectedIndex = -1;
	private String[] details;

	
    public ListSitesDetails(Context context, ArrayList<ListSites> itens) {
        this.itens = itens;
        mInflater = LayoutInflater.from(context);
    }
    
    
    public void setSelectedIndex(int selectedIndex){
    	this.selectedIndex = selectedIndex;
    }
    
    
    public void setSelectedFileDetails(String[] details){
    	this.details = details;
    }
    
    
    public int getSelectedIndex(){
    	return this.selectedIndex;
    }

    public ListSites getSelectedItem(){
        return itens.get(selectedIndex);
    }

    public void remove(int index){
        itens.remove(index);
        this.notifyDataSetChanged();
    }

    public int getCount() {
        if(itens==null){
            return 0;
        }
        return itens.size();
    }
	 

    public ListSites getItem(int position) {
        return itens.get(position);
    }
    
    
    public String getUrl(int position) {
        return itens.get(position).getUrl();
    }
    

    public long getItemId(int position) {
        return position;
    }
    
	 
    public View getView(int position, View view, ViewGroup parent) {
    	ListSites item = itens.get(position);
        view = mInflater.inflate(R.layout.list_testsites, null);
        
        if(selectedIndex != -1 && selectedIndex == position && details != null){
        	((TextView) view.findViewById(  R.id.txt_file_details  )).setText(  details[0]  );
        	((TextView) view.findViewById(  R.id.txt_audio_files   )).setText(  details[1]  );
        	((TextView) view.findViewById(  R.id.txt_pictures      )).setText(  details[2]  );        	
        	((TextView) view.findViewById(  R.id.txt_operator      )).setText(  details[3]  );
        	((TextView) view.findViewById(  R.id.txt_objects       )).setText(  details[4]  );
        	((TextView) view.findViewById(  R.id.txt_tests         )).setText(  details[5]  );
        	
        	((TextView) view.findViewById(R.id.txt_testsite)).setTypeface(null, Typeface.BOLD);
        	((TextView) view.findViewById(R.id.txt_filedate)).setTypeface(null, Typeface.BOLD);
        	
        	view.findViewById(R.id.hidden_params).setVisibility(View.VISIBLE);
        } else {
        	view.findViewById(R.id.hidden_params).setVisibility(View.GONE);
        }

        ((TextView) view.findViewById(R.id.txt_testsite)).setText(item.getSiteName());
        try {
            ((TextView) view.findViewById(R.id.txt_filedate)).setText(item.getFileDate().split(" ")[0]);
        } catch (Exception e){
            ((TextView) view.findViewById(R.id.txt_filedate)).setText(item.getFileDate());
        }
         
        return view;
    }



	
	
	
	
	
	
}
