package com.megabras.bluelogg.tm25r;

import android.content.Context;
import android.os.Bundle;
//import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ListView;

import com.megabras.bluelogg.R;
import com.megabras.modbus.TM25R.Measurement;
import com.megabras.modbus.TM25R.TestData;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Observable;
import java.util.Observer;

import androidx.fragment.app.Fragment;

//public class Table extends Fragment implements Observer{
public class Table extends Fragment {
    @SuppressWarnings("unused")
    private final String
            TAG                 = "TableFragment";

    public static final int
            RESISTANCE_CHART    = 0,
            VOLTAGE_CHART       = 1,
            CURRENT_CHART       = 2,
            TABLE               = 3;

    private int
            CHART_TYPE          = -1;

    protected DecimalFormat
            dosDigitos;

    private LinearLayout
            layout;

    private ListView
            list;

    private TableBaseAdapter
            adapter;

    private String
            chartTitle          = "";

    private Context
            context;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        context = inflater.getContext();
        return inflater.inflate(R.layout.md10kvx_fgr_online, container, false);
    }

    @Override
    public void onStart() {
        super.onStart();
        createChart();
    }

    public void setChartType(int type, String chartTitle){
        CHART_TYPE = type;
        this.chartTitle = chartTitle;
    }

    public int getChartType(){
        return CHART_TYPE;
    }

    private void createChart(){
        dosDigitos = new DecimalFormat("#.##");

        switch (CHART_TYPE) {
            case Table.TABLE:
                Table();
                break;
        }
    }

    public void Table()
    {
        if( this.getView()!=null )
            layout = this.getView().findViewById(R.id.chart);
        else
            return;

        if( layout.getChildCount()>1 )
            return;

        list = new ListView( layout.getContext() );
        list.setDividerHeight(0);
        layout.addView(list);

        adapter = new TableBaseAdapter( layout.getContext() );
        list.setAdapter( adapter );
        list.setVisibility(View.VISIBLE);
    }

    public int getTableSize(){
        if(adapter != null){
            return adapter.getCount();
        }
        else {
            return 0;
        }
    }

    public void update(Measurement measurement){
        adapter.add(measurement);
        adapter.repaint();
    }

    public void repaint(){
        switch (CHART_TYPE) {
            case 3:
                adapter.repaint();
                break;
        }
    }

    public void setAllValues(ArrayList<Measurement> measurements)
    {
        adapter.clear();

        for (Measurement m : measurements) {
            adapter.add(m);
        }

        adapter.repaint();
    }

    public void reset(){
        try{
            if (layout==null){
                createChart();
            }
            if(CHART_TYPE==TABLE){
                adapter.clear();
                adapter.repaint();
                layout.removeAllViews();
                layout.addView(list);
            }
        } catch (Exception e){
            Log.e("ERROR", e.getMessage()+"");
        }
    }

//    @Override
//    public void update(Observable o, Object arg) {
//        if (o instanceof TestData)
//        {
//            TestData testData = (TestData) o;
//            int itemID = (int) arg;
//            switch (itemID){
//                case TestData.ID_MEASUREMENT:
//                    for (Measurement m : testData.getMeasurements()) {
//                        Log.e(TAG, m.getTestNumber() + "  " + m.getDate());
//                    }
//                    break;
//            }
//        }
//    }
}
